/*
 *	3DShell
 *	Backdrop.cpp - Implements the backdrop
 *	Iain C, DATEMARK
 */

// ********************************* INCLUDES **********************************************

#include "GeneralHeader.h"

// ********************************* CONSTRUCTORS/DESTRUCTORS **********************************************

CBackdrop::CBackdrop()
{
}

CBackdrop::~CBackdrop()
{
}

// ********************************* METHODS **********************************************

int CBackdrop::PostGLInit(int m_NamesOffset)	// Construct display list for backdrop, set base name
{
	NamesOffset = m_NamesOffset;

	char filename[11];
	sprintf(filename, "gfx/sky.bmp");
	cTextureBackdrop.CreateFromFile(filename, 2);

	// Build display list for backdrop
	glNewList(2,GL_COMPILE);
		cTextureBackdrop.Use();
		cTextureBackdrop.SaveState();
		// cTextureBackdrop.EnvironmentMapping();
		glDisable(GL_DEPTH_TEST); // Cos it's a skybox
			glPushMatrix();
				glScalef(50.0f,50.0f,50.0f);
				glBegin(GL_QUADS);
					glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, 1.0f, 1.0f);
					glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, 1.0f, 1.0f);
					glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 1.0f);
					glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 1.0f);

					glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
					glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, 1.0f, -1.0f);
					glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f);
					glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);

					glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, 1.0f, -1.0f);
					glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, 1.0f, 1.0f);
					glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, 1.0f, 1.0f);
					glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f);

					glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 1.0f);
					glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 1.0f);
					glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
					glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);

					glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 1.0f);
					glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, 1.0f, 1.0f);
					glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f, 1.0f, -1.0f);
					glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);

					glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f);
					glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, 1.0f, 1.0f);
					glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 1.0f); 
					glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
				glEnd();
			glPopMatrix();
		glEnable(GL_DEPTH_TEST); 
		cTextureBackdrop.RestoreState();
		cTextureBackdrop.EndUse();
	glEndList();

	return TRUE;
}

int CBackdrop::Draw()	// Draw the backdrop.
{
	glLoadName(NamesOffset+1);
	//glCallList(2);							// Draw the Wharf
	return TRUE;
}

int CBackdrop::ProcessHit(int ObjectName)	// Process a hit on one of our objects
{
	//MessageBox (NULL, "Backdrop got a hit!", "Hits!", MB_OK);
	return TRUE;
}
