/*
 *	3DShell
 *	GeneralHeader.h - Header file for all modules
 *	Iain C, DATEMARK
 */

// ********************************* DEFINES **********************************************

#define RES_BITDEPTH				32				// Bitdepth to try & get a PFD for
#define WINDOW_TITLE				"3DShell"		// Title for the app window
#define OBJECT_GROUP_OFFSET			100				// For object picking: Distance between groups
#define BASENAME_DUMMY				1000			// For object picking: Dummy basename to use to prime the stack
#define MAX_OBJECTS					500				// For object picking: Max objects in system
#define MIN_Z						-10000000		// For object picking: Min Z value in world
#define CAMPATH_TRACK_TO_WHARF		1				// Camera tracking paths
#define CAMPATH_TRACK_TO_TASKMAN	2
#define CAMPATH_TRACK_OVER_FRAMES	15				// Number of frames cam takes to track to a viewpoint

// ********************************* INCLUDES **********************************************

#include <windows.h>								// For Win-specific stuff
#include <gl\gl.h>									// For OpenGL32
#include <gl\glu.h>									// For GLu32
#include <gl\glaux.h>								// For Glaux
#include <stdio.h>									// For file stuff
#include <stdlib.h>
#include <math.h>									// For maths stuff

#include "Texture.h"								// CTexture class
#include "Backdrop.h"								// CBackdrop class
#include "Wharf.h"									// CWharf class
#include "Task.h"									// CTask class
#include "TaskManager.h"							// CTaskManager class
#include "Scene.h"									// CScene graph class
#include "HookMDesktopsProject/HookMDesktops.h"		// For window hook DLL
