// HookMDesktops.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "HookMDesktops.h"
//#include "WindowsData.h"	IC


//House Keeping
HANDLE instanceHandle;
bool initCalled;


//The  hooks
HHOOK shellHook;

// Shared DATA
#pragma data_seg(".SHARDATA")
static HWND mainWindow = NULL;		//The Window handle of the container of the data we're listening to
																	//We get this pointer from the app.

static UINT message = 0;					//Protocol by which we communicate.
#pragma data_seg()


//CBT_HOOK, this is the hook to install to trap create window calls
extern "C" 
{
LRESULT HOOKMDESKTOPS_API __stdcall ShellProc(int nCode, WPARAM wParam, LPARAM lParam);
}


//Dll House Keeping function.
BOOL APIENTRY DllMain(HANDLE hModule, 
                      DWORD  ul_reason_for_call, 
                      LPVOID lpReserved)
{
  switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		{
			instanceHandle = hModule;
		}
		break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
  }
  return TRUE;
}


HOOKMDESKTOPS_API bool InitHooksDll(HWND window, UINT msg)
{
	//The window with which we communicate
	mainWindow = window;

	//The message we communicate
	message = msg;

	initCalled = true;
  return (initCalled);
}

HOOKMDESKTOPS_API bool ShutdownHooksDll()
{
	if(initCalled)
	{
		return true;
	}
	return false;
}

HOOKMDESKTOPS_API bool InstallFilters()
{
	//Sanity check.
  if (!initCalled)
	{
		return (false);
  }

	//We want to be notified when actions occur to top-lecel windows 
	shellHook = 
	SetWindowsHookEx(WH_SHELL, (HOOKPROC)ShellProc, (HINSTANCE)instanceHandle, 0);

	return true;
}

HOOKMDESKTOPS_API bool UnInstallFilters()
{
	bool ret = false;

	//Sanity check.
  if (!initCalled)
	{
		return (ret);
  }

	//Unhook our hooks
	ret = UnhookWindowsHookEx(shellHook) ? true : false;

	return ret;
}



LRESULT HOOKMDESKTOPS_API __stdcall ShellProc(int nCode, WPARAM wParam, LPARAM lParam)
{

	if(nCode > 0)
	{
		switch(nCode)
		{
			case HSHELL_WINDOWCREATED:
			{
				//A Top level, unowned window has been created, basically exactly
				//what we're looking for.
				::PostMessage(mainWindow, message, MD_SH_CREATED, (LPARAM)wParam);
			}
			break;
			case HSHELL_WINDOWACTIVATED:
			{
				//Activation change.
				::PostMessage(mainWindow, message, MD_SH_ACTIVATED, (LPARAM)wParam);
			}
			break;
			case HSHELL_WINDOWDESTROYED:
			{
				//A Top-level, unowned window is about to be destroyed.
				::PostMessage(mainWindow, message, MD_SH_DESTROYED, (LPARAM)wParam);
			}
			break;
			default:
			break;
		}
	}

  //
  // We looked at the message ... sort of processed it but since we are only
  // looking we will pass all messages on to CallNextHookEx.
  //
  return(CallNextHookEx(shellHook, nCode,wParam, lParam));
	
}