/*
 *	3DShell
 *	Task.cpp - Implements a Task
 *	Iain C, DATEMARK
 */

// ********************************* INCLUDES **********************************************

#include "GeneralHeader.h"

// ********************************* CONSTRUCTORS/DESTRUCTORS **********************************************

CTask::CTask(HWND m_hWnd, int m_ObjectName)
{
	RECT WRect;						// To get dimensions of window

	ObjectName = m_ObjectName;		// Set object name
	hWnd = m_hWnd;					// Set hWnd

	GetWindowRect(hWnd, &WRect);	// Get window dimensions
	
//	char buffer[1024];
	WindowWidth=(int)WRect.right-WRect.left;
	WindowHeight=(int)WRect.bottom-WRect.top;
//	sprintf("Width:%d Height:%d", buffer, WindowWidth, WindowHeight);

	// MARK: Got here....
	//cout << buffer;

	tex.CreateFromWindow(hWnd);
}

CTask::~CTask()
{
}

// ********************************* METHODS **********************************************

int CTask::Draw()		// Draw it
{
	glLoadName(ObjectName);
	tex.Use();
	tex.SaveState();
	tex.Transparency();
	glFrontFace(GL_CCW);
	glBegin(GL_QUADS);
		float size=5.0f;
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(-size, -size, 0.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(-size, size, 0.0f);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(size, size, 0.0f);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(size, -size, 0.0f);
	glEnd();
	tex.RestoreState();
	tex.EndUse();

	return TRUE;
}

int CTask::RebuildTexture()	// Reconstruct the texture
{
	tex.CreateFromWindow(hWnd);
	return TRUE;
}