/*
 *	3DShell
 *	Task.h - Header file for class CTask, representing a task controlled by the task manager
 *	Iain C, DATEMARK
 */

class CTask
{
public:
	// Constructor & destructor
	CTask(HWND hWnd, int m_ObjectName);	// New object to represent task with HWND hWnd, and an exclusive object name (for picking)
	virtual ~CTask();

	// Functions
	int			Draw();				// Draw the quad
	int			RebuildTexture();	// Rebuild the texture

	// Properties
	int			ObjectName;			// Object name of task (For GL picking)
	HWND		hWnd;				// hWnd of task we represent
	CTask * next;					// Pointer to next task in linked list

private:
	// Properties
	CTexture	tex;				// Texture for the quad (generated from the hWnd)
	int			WindowWidth;		// Width of window we represent
	int			WindowHeight;		// Height of window we represent
	float		QuadWidth;			// Width of quad used to display window (in world co-ords)
	float		QuadHeight;			// Height of quad used to display window (in world co-ords)
};
