// This is a class for a sorted linked list of integers.

#include <bool.h>
#include <iostream.h>

class LinkedList
{
 private:

  struct node
  {
   int info;
   node * next;
  };

  typedef node * nodeptr;

  nodeptr start;

  int count;

 public:

// Constructor

 LinkList()
 {
  start = NULL;
  count = 0;
 }

// Destructor

 ~LinkedList()
 {
  nodeptr p = start, n;
 
  while (p != NULL)
  {
   n = p;
   p = p->next;
   delete n;
  }
 }
 
// Put a node into the linked list with the value x so the
// list remains sorted in ascending order.

 void AddNode(int x);

// Delete the first node found with the value x, if one exists.
// Return value indicates whether such a node was found.

 bool DeleteNode(int x);

// Output the values in the nodes, one integer per line. 

 void ListNodes();

// Return true if there in a node in the list with the value x.

 bool IsInList(int x);

// Return a count of the number of nodes in the list.
 
 int Size();
};

void LinkedList::AddNode(int x)
{
 nodeptr n, prev, cur;

 n = new node;
 n->info = x;
 count = count + 1;

 if (start == NULL)
 {
  start = n;
  n->next = NULL;
 }
 else
 {
  cur = start;
  while ( cur != NULL && x > cur->info )
  {
   prev = cur;
   cur = cur->next;
  }

  if (cur == start)
  {
   n -> next = start;
   start = n;
  }
  else
  {
   prev->next = n;
   n -> next = cur;
  }
 }

}


bool LinkedList::DeleteNode(int x)
{
 nodeptr prev, cur;
 bool found = false;

 cur = start;

 while (cur != NULL && x > cur->info)
 {
  prev = cur;
  cur = cur->next;
 }

 if (cur != NULL)
 {
  if (x == cur->info)
  {
   if ( cur == start )
    start = start->next;
   else
    prev->next = cur->next;
 
   delete cur;
   count--;
   found = true;
  }
 }

 return found;

}

void LinkedList::ListNodes()
{
 nodeptr p = start;

 while (p != NULL)
 {
  cout << p->info << endl;
  p = p->next;
 }

}

bool LinkedList::IsInList(int x)
{
 nodeptr p = start;

 while (p != NULL && x > p->info)
  p = p->next;

 if (p != NULL)
  return (x == p->info);
 else
  return false;
 
}

int LinkedList::Size()
{
 return count;
} 

