/*
 *	3DShell
 *	TaskManager.h - Header file for class CTaskManager - the task manager
 *	Iain C, DATEMARK
 */

class CTaskManager
{
public:
	// Constructor & destructor
	CTaskManager();
	virtual ~CTaskManager();

	// Functions
	int		Draw();							// Draw the tasks
	int		PostGLInit(int m_NamesOffset);	// Do post-GL init
	int		ProcessHit(int ObjectName);		// Process a hit on a task
	int		AddTask(HWND hWnd);				// Add a task to the list
	int		RemoveTask(HWND hWnd);			// Remove a task from the list
	int		UpdateTask(HWND hWnd);			// Update a task if it exists, else add a new one

private:
	// Functions
	bool	IsInList(HWND hWnd);			// Check if a task exists in the list

	// Properties
	typedef CTask * nodeptr;
	nodeptr start;							// Pointer to first task in the linked list
	int		TaskCount;						// Number of tasks in the linked list
	int		NamesOffset;					// 1st object name we're allowed to assign
};
